#include <windows.h>
#include <stdio.h>

int wmain(int argc, WCHAR **argv)
{
    LPTSTR lpszVariable; 
    LPWCH lpvEnv; 
 
    // Get a pointer to the environment block 
    lpvEnv = GetEnvironmentStrings();

    // If the returned pointer is NULL, exit
    if (lpvEnv == NULL)
    {
        wprintf(L"GetEnvironmentStrings() failed! Error %d\n", GetLastError()); 
        return 0;
    }
	else
		wprintf(L"GetEnvironmentStrings() is OK!\n\n");
 
    // Variable strings are separated by NULL byte, and the block is 
    // terminated by a NULL byte
    lpszVariable = (LPTSTR)lpvEnv;

    while(*lpszVariable)
    {
        wprintf(L"%s\n", lpszVariable);
        lpszVariable += lstrlen(lpszVariable) + 1;
    }
	// Frees a block of environment strings
    if(FreeEnvironmentStrings(lpvEnv) != 0)
		wprintf(L"FreeEnvironmentStrings() - a block of environment strings was freed!\n");
	else
		wprintf(L"FreeEnvironmentStrings() failed, error %u\n", GetLastError());
    return 1;
}
